.gba
.open "zm.gba","spiderball.gba",0x8000000
;by : JumZhu.Diwa
.definelabel XTagRAM,30007F0h
.definelabel YTagRAM,30007F1h
.definelabel CheckSlope,800F360h
.definelabel CheckBlock,800F688h         ; Check 7F1 is suitable for overhead
.definelabel CheckBlock2,800F47Ch        ; Check 7F0 is suitable for the body
.definelabel CheckBlock3,800f720h
.definelabel Division,808AC34h
.definelabel PlaySound,8002A18h
.definelabel PlaySound2,8002b20h
.definelabel PlaySound3,8002c80h
.definelabel SamusHeightStage,30015DFh	; stand 0 squat 1 ball 2
; Implement the spider ball
;notes:
; Ball shape press up / down / left / right + L, if there is a wall up / down / left / right, the spider ball will be activated
; Press + L not only to stick to the ground, but also to the ceiling
; Press + L (there must be an instant button) to cancel the spider ball in any situation


; 3001384 is the spider ball Pose 1 on the ground 2 on the ceiling 3 on the left wall 4 on the right wall
; 3001385 is the continuous action value of the spider ball, see below
; 3001384 indicates the continuous key direction, specifically right 10 left 20 up 40 down 80
; 3001385 is 1 when the direction of the button is confirmed to be pressed, the spider ball is only 1 when it is moved down or to the right
; 3001385 will become 2 after the spider ball is activated, to control you must press + L immediately to deactivate the spider ball
; 3001385 When the spider ball is blown up, it will lose the spider ball and get the number of 8, decrementing from 8 by 8 each frame to 2 to activate the spider ball

.org	0x8008A64
	ldrb	r1,[r0,12h] ; morph on ground
	mov		r0,2h
	and		r0,r1
	cmp		r0,2h
.org	0x8008D10		;morph in air
	ldrb	r1,[r0,12h]
	mov		r0,2h
	and		r0,r1
	cmp		r0,2h
.org	0x800968A		;morph from hanging
	ldrb	r1,[r0,12h]
	mov		r0,2h
	and		r0,r1
	cmp		r0,2h


.org 0x84428C0
  .import "spiderlabel.data"

.org 0x8760160
  .word 08761fb8h
  .word 08761fb8h
  .word 08761fb8h
  .word 08761fb8h
  .word 08761fb8h
.org 0x8761fb8
  .import "rawgraphics.data"

.org 0x82B2B48
  .import "spideritem.palette"

.org 0x844591A
   .import "spiderdescription.data"

; Spherical ball rolling three checks in the air
.org 800924Eh
	bl 		TheSpiderBall
	
.org 8009532h
	bl 		TheSpiderBall
	
.org 80093C2h
	bl		TheSpiderBall
	
.org 80077ACh					; change appropriate animation
	bl		BallAnimationControl
	
.org 800B4CAh					; Change Full Outfit + Gravity Suit Palette
	mov 	r3,2h
	bl		SpiderBallPaletteChanged
; In normal games, the prerequisite for turning on gravity is full installation
.org 800B522h					; change full-load gravity-free palette
	mov		r3,3h
	bl		SpiderBallPaletteChanged
; Is this really useful in normal games! Gravity cannot be turned off, and gravity is turned on when fully installed
.org 800B57Eh					; change non-full-fitting + insulation palette
	mov		r3,1h
	bl		SpiderBallPaletteChanged
; mage's debugging mode will change some calls, making full installation + insulation possible
.org 800B5CEh					; change no full-equipped non-insulated palette
	mov		r3,0h
	bl		SpiderBallPaletteChanged
; It's the starting costume!

.org 8761D38h					; useless data at the end
.align
SpiderBallPalette:
.import "spiderBall.palette"

; Offset 0 is the spider ball palette of the base suit
; Offset 20 is the afterimage color
; Offset 40 as the basic suit of the spider ball gold body palette

; Offset A0 is the spider ball palette for thermal insulation
; Offset C0 is the above residual color
; Offset E0 is the spider ball gold body palette for thermal insulation

; Offset 140 is the spider ball palette for gravity suit
; Offset 160 is the top afterglow
; Offset 180 for gravity ball spider body golden palette

; Offset 1E0 for full-service spider ball palette
; Offset 200 for the afterimage
; Offset 220 is full-bodied spider ball gold body palette
	
.org 8304054h					; Address of unwanted data
TheSpiderBall:
	push	r0,lr
	mov		r2,0h
	ldr		r0,=3001542h		; current armor
	ldrb	r0,[r0]
	cmp		r0,2h				; non-zero suit will activate the spider ball
	beq		@@CorrectReturn
	ldr		r0,=300153Fh		; current suitmisc status
	ldrb	r0,[r0]
	mov		r2,40h
	and		r0,r2
	mov		r2,0h
	cmp		r0,0h				; non-zero suit will activate the spider ball
	beq		@@CorrectReturn
	bl		SpiderBallMain
@@CorrectReturn:
	pop		r0	
	ldr		r1,=30013D4h
	ldrb	r1,[r1]
	cmp		r2,0h				; Pose tagged spider ball
	bne		@@OtherCome
	cmp		r1,11h				; ground ball
	beq		@@MorphNormalPose
	cmp		r1,12h				; rolling ball
	beq		@@MorphRollingPose
	cmp		r1,14h				; aerial ball
	bne		@@end
	ldrh	r1,[r0]
	mov		r0,40h
	b 		@@end
.pool
@@MorphNormalPose:
	mov		r4,r0
	ldrb	r0,[r4,4h]
	b 		@@end
@@MorphRollingPose:
	ldrh	r1,[r0]
	mov		r2,1h
	b		@@end
@@OtherCome:
	pop		r3
	cmp		r1,11h
	beq		@@MorphNormalSpiderBallPose
	cmp		r1,12h
	beq		@@MorphRollingSpiderBallPose
	ldr		r3,=80095FAh
	b		@@SpiderBallRetrun
	.pool
@@MorphNormalSpiderBallPose:
	ldr		r3,=80093AAh
	b		@@SpiderBallRetrun
	.pool
@@MorphRollingSpiderBallPose:
	ldr		r3,=8009464h
	b		@@SpiderBallRetrun
	.pool
@@end:
	pop		r3
@@SpiderBallRetrun:	
	mov		r15,r3
.pool
	
SpiderBallMain:
	push	r4-r7,lr
	ldr		r0,=300137Ch		; input
	ldr		r6,=XTagRAM
	mov		r7,0F0h
	mov		r4,r0
	mov		r5,r4
	add		r5,58h				; get 30013d4
	bl		SpiderBallSuitableControl
	bl		SpiderBallCheckRemove
	bl		SpiderBallPreciseCoordinates
	ldrb	r0,[r4,8h]
	lsl		r0,r0,2h
	ldr		r1,=SpiderBallPoseTable
	add		r0,r1
	ldr		r0,[r0]
	mov		r15,r0
.pool
SpiderBallPoseTable:
	.word	SpiderBallCheckFlag
	.word	SpiderBallOnFloor
	.word	SpiderBallOnCeiling
	.word 	SpiderBallOnLeftWall
	.word	SpiderBallOnRightWall
SpiderBallCheckFlag:
	bl		SpiderBallCheckFlagPose
	b		@Thend
SpiderBallOnFloor:
	bl		SpiderBallOnFloorPose
	b		@Thend
SpiderBallOnCeiling:
	bl		SpiderBallOnCeilingPose
	b 		@Thend
SpiderBallOnLeftWall:
	bl		SpiderBallOnLeftWallPose
	b		@Thend
SpiderBallOnRightWall:
	bl		SpiderBallOnRightWallPose
	
@Thend:	
	ldrb	r2,[r4,8h]
	pop		r4-r7
	pop		r1
	bx		r1
.pool
	
SpiderBallPreciseCoordinates:	; at any time make the spider ball against the wall to modify the door switch to change the coordinates
	ldrb	r1,[r4,8h]			; read the spider ball Pose
	cmp		r1,1h				; if greater than 1
	bls		@@end
	cmp		r1,2h
	bhi		@@NoCeilingPose
	ldrh	r0,[r5,14h]			; correct Y coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,3Ch
	strh	r0,[r5,14h]
	b 		@@end
@@NoCeilingPose:
	ldrh	r0,[r5,12h]			; correct X coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	cmp		r1,3h
	bne		@@RightWallPose
	add		r0,1Ch
	b		@@WriteFixX
@@RightWallPose:
	add		r0,23h
@@WriteFixX:
	strh	r0,[r5,12h]
@@end:
	bx		r14
.pool	

SpiderBallCheckRemove:			; Check the removal of the spider ball
	push	r4-r7,lr
	add		sp,-10h
	mov		r2,r5
	add		r2,20h				;30013F4
	ldrb	r0,[r2]				; Read the previous pose
	cmp		r0,31h				; if the ball is injured 1
	beq		@@AllReturnSpiderBallZero
	cmp		r0,32h				; ball injury 2
	beq		@@AllReturnSpiderBallZero
	ldrb	r1,[r4,9h]
	cmp		r1,2h
	bne		@@PassAllReturnZero
	cmp		r0,27h				; end of ball sprint
	bne		@@end
	mov		r0,20h
	strb	r0,[r2]				; Change the previous Pose value to prevent repetition
@@AllReturnSpiderBallZero:
	mov		r0,0h
	strh	r0,[r4,8h]			; all zeros
	b		@@end	
@@PassAllReturnZero:	
	ldrb	r0,[r4,8h]
	cmp		r0,0h				; check spider ball start
	beq		@@end				; End without starting
	ldrh	r0,[r4]				; read input
	mov		r1,080h
	lsl		r1,r1,2h
	and		r0,r1
	lsr		r0,r0,2h
	cmp		r0,0A0h
	;bne		@@CheckBombContact				; check if you pressed and L
	ldrh	r0,[r4,4h]			; read immediate input
	and		r0,r1
	cmp		r0,0h				; cancel the spider ball with instant input
	beq		@@CheckBombContact
	; beq		@@end
	mov		r0,0h				; and mark cancel
	strb	r0,[r4,8h]
	mov		r0,1h
	strb	r0,[r4,9h]			; mark unmarked
	ldr		r0,=24Fh
	bl		PlaySound2
	b		@@end
	.pool
@@CheckBombContact:
	ldr		r7,=3000A2Ch		; ammunition data address
	ldr		r6,=30015D8h		; character judgment address
@@Loop:	
	ldrb	r0,[r7]
	mov		r1,1h
	and		r0,r1
	cmp		r0,0h				; check if it is a valid projectile
	beq		@@NextPro			; check the next if it is invalid
	ldrb	r0,[r7,0Fh]
	cmp		r0,0Eh				; check if it is a bomb
	bne		@@NextPro			; not check next
	ldrb	r0,[r7,11h]
	cmp		r0,3h				; check that the rhythm of the bomb is an explosion>
	bne		@@NextPro			; not check next
	ldrh	r0,[r7,8h]			; Y coordinate of the bomb
	ldrh	r1,[r7,14h]			; The upper part of the bomb is determined
	add		r1,r0
	lsl		r1,r1,10h
	lsr		r1,r1,10h
	str		r1,[sp]				;Egg on the pole 
	ldrh	r1,[r7,16h]			; the lower part of the bomb is determined
	add		r1,r0
	str		r1,[sp,4h]			;Egg Down
	ldrh	r0,[r7,0Ah]			; X coordinate of the bomb
	ldrh	r1,[r7,18h]			; the left part of the bomb is judged
	add		r1,r0
	lsl		r1,r1,10h
	lsr		r1,r1,10h
	str		r1,[sp,8h]			; the egg is far left
	ldrh	r1,[r7,1Ah]			; the right part of the bomb is determined
	add		r1,r0
	str		r1,[sp,0Ch]			; far right
	ldrh	r1,[r5,12h]			; character's X coordinate
	ldrh	r2,[r6]				; character left determination
	add		r2,r1
	lsl		r2,r2,10h
	lsr		r2,r2,10h			; person is extremely left
	ldrh	r3,[r6,2h]			; character right
	add		r3,r1				; extreme right
	ldrh	r1,[r5,14h]			; the Y coordinate of the character
	ldrh	r0,[r6,4h]			; character upper judgment
	add		r0,r1
	lsl		r0,r0,10h
	lsr		r0,r0,10h			; on the pole
	bl		800E6F8h			; check if intersect
	cmp		r0,0h
	beq		@@NextPro
	; b		@@AllReturnSpiderBallZero
	mov		r0,0h
	strb	r0,[r4,8h]
	mov		r0,8h
	strb	r0,[r4,9h]
	b		@@end
.pool
@@NextPro:
	add		r7,1Ch
	ldr		r0,=3000BECh		; Ammo data end address
	cmp		r7,r0
	bcc		@@Loop
@@end:
	add		sp,10h
	pop		r4-r7
	pop		r1
	bx		r1
.pool	
	
SpiderBallSuitableControl:		; Used to change between two frames
	push	lr
	ldrb	r0,[r4,9h]
	cmp		r0,0h
	bne		@@EndTransferStation				; end if it is a continuous keypress
	ldrb	r2,[r4,8h]
	cmp		r2,0h
	beq		@@EndTransferStation				; ends without opening the spider ball
	cmp		r2,2h
	bhi		@@LeftAndRightWallPose
	ldrb	r3,[r4]				; read input
	mov		r1,30h				; check if the border is up or down
	and		r1,r3
	cmp		r1,0h
	bne		@@EndTransferStation			; end if left and right are pressed
	mov		r1,0C0h				; if you don't press left and right, check if you press up and down
	and		r1,r3
	cmp		r1,0h
	beq		@@EndTransferStation	; end without pressing up and down
	cmp		r2,1h
	bne		@@CeilingPose		; check if it is on the ground
	mov		r1,40h
	and		r1,r3				; check if the
	cmp		r1,0h				; press the words
	bne		@@CheckInSide		; check inside angle
	ldrh	r0,[r5,14h]			; check outer angle
	ldrh	r1,[r5,12h]
	add		r0,20h
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	beq		@@FloorLeftDownNoBlock
	ldrh	r0,[r5,14h]			; right outer corner judgment
	ldrh	r1,[r5,12h]
	add		r0,20h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	bne		@@EndTransferStation		; end if there are bricks on both sides
	mov		r0,81h				; press to move right
	b 		@@WriteNewStillingPress
@@FloorLeftDownNoBlock:			
	mov		r0,80h				; press to move left
	b		@@WriteNewStillingPress	
@@CeilingPose:
	mov		r1,80h
	and		r1,r3
	cmp		r1,0h				; if the ceiling is pressed down
	bne		@@CheckInSide		; check inside angle
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,60h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@CeilingRightUpNoBlock
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,60h
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@EndTransferStation	; end with bricks on both sides
	mov		r0,40h				; press to move left
	b		@@WriteNewStillingPress
@@CeilingRightUpNoBlock:		; if there is no brick on the top right
	mov		r0,41h				; press to move right
	b		@@WriteNewStillingPress
@@CheckInSide:	
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,1Eh
	sub		r1,3Ch			; multi-half grid pixels
	bl		CheckBlock		; check if there is a border on the left
	ldrb	r0,[r6,1h]
	and		r0,r7				
	cmp		r0,0h
	beq		@@CheckRightWall	; check if there is no border on the left
	; ldrh	r0,[r5,12h]			; Correct coordinates
	; lsr		r0,r0,6h
	; lsl		r0,r0,6h
	; add		r0,1Ch
	; strh	r0,[r5,12h]
	ldrb	r0,[r4,8h]
	cmp		r0,1h
	bne		@@CeilingPoseInsideLeft
	mov		r0,40h
	b		@@WriteNewStillingPress ; move to the left and touch the ground
@@CeilingPoseInsideLeft:
	mov		r0,80h
	b		@@WriteNewStillingPress	; ceiling press moves to the left
	; mov		r2,3h				; write new Pose on the left border
	; b		@@WriteNewPose
@@EndTransferStation:
	b		@@end
	
@@CheckRightWall:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,1Eh
	add		r1,3Ch				; add half grid pixels
	bl		CheckBlock			; check if there is a border on the right
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h	
	beq		@@end				; end without border on the right
	; ldrh	r0,[r5,12h]			; Correct coordinates
	; lsr		r0,r0,6h
	; lsl		r0,r0,6h
	; add		r0,23h
	; strh	r0,[r5,12h]
	ldrb	r0,[r4,8h]
	cmp		r0,1h
	beq		@@FloorPoseInsideRight
	mov		r0,81h
	b		@@WriteNewStillingPress
@@FloorPoseInsideRight:
	mov		r0,41h
	b		@@WriteNewStillingPress
	; mov		r2,4h
	; b		@@WriteNewPose		; on the right border write new Pose
@@LeftAndRightWallPose:	
	ldrb	r3,[r4]
	mov		r1,0C0h				; check if the top and bottom are pressed
	and		r1,r3
	cmp		r1,0h
	bne		@@end				; press up and down to end
	mov		r1,30h				
	and		r1,r3				; check if left and right are pressed
	beq		@@end				; end without pressing left or right
	mov		r1,20h
	and		r1,r3				; check if left is pressed
	cmp		r1,0h
	beq		@@PressRight
	ldrb	r0,[r4,8h]			; Spider Pose
	cmp		r0,4h				; whether it is bordered by the left wall
	beq		@@LeftAndRightWallInside ; right wall press left is inside corner
	ldrh	r0,[r5,14h]			; left borders press left
	ldrh	r1,[r5,12h]
	add		r0,4h				
	sub		r1,20h				
	bl		CheckBlock			; check bottom left
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@LeftWallDownLeftNoBlock
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	sub		r1,20h				; check top left
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@end				; end with bricks above and below
	mov		r0,20h				; left button to move
	b		@@WriteNewStillingPress
@@LeftWallDownLeftNoBlock:		; bordering left no bricks left bottom
	mov		r0,21h				; move left with the left button
	b 		@@WriteNewStillingPress
@@PressRight:
	ldrb	r0,[r4,8h]			
	cmp		r0,4h				; check if it is not on the right wall
	bne		@@LeftAndRightWallInside	; inside corner check if not
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	add		r1,20h
	bl		CheckBlock			; right wall border right button check top right
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@RightWallPoseRightUpNoBlock
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,4h
	add		r1,20h
	bl		CheckBlock			; check bottom right
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@end				; the right wall is bordered by bricks
	mov		r0,11h				; right border and move down right
	b		@@WriteNewStillingPress
@@RightWallPoseRightUpNoBlock:
	mov		r0,10h				; right borders move up right
	b		@@WriteNewStillingPress
@@LeftAndRightWallInside:	
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h				; downward half grid pixels
	bl		CheckBlock			; check if the ground borders
	ldrb	r0,[r6,1h]			
	cmp		r0,0h
	beq		@@CheckCeiling		; check the ceiling if the ground is not bordered
	; ldrh	r0,[r5,14h]			; Correct coordinates
	; lsr		r0,r0,6h
	; lsl		r0,r0,6h
	; add		r0,3Fh
	; strh	r0,[r5,14h]
	ldrb	r0,[r4,8h]
	cmp		r0,3h
	bne		@@RightWallPressLeftMoveDown
	mov		r0,11h				; move left wall by right and down
	b		@@WriteNewStillingPress
@@RightWallPressLeftMoveDown:	
	mov		r0,21h				; move left wall down
	b		@@WriteNewStillingPress
@@CheckCeiling:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,5Ch				; upward half grid pixels
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	beq		@@end				; the ceiling ends without borders
	; ldrh	r0,[r5,14h]			; Correct coordinates
	; lsr		r0,r0,6h
	; lsl		r0,r0,6h
	; sub		r0,4h
	; strh	r0,[r5,14h]
	ldrb	r0,[r4,8h]
	cmp		r0,4h
	bne		@@LeftWallPosePressRightUpMove
	mov		r0,20h				; right wall border left move up
	b		@@WriteNewStillingPress
@@LeftWallPosePressRightUpMove:	
	mov		r0,10h				; left wall border right move up
@@WriteNewStillingPress:
	strb	r0,[r4,9h]
@@end:	
	pop		r1
	bx		r1
.pool		
	
SpiderBallCheckFlagPose:		; Check if you want to turn on the spider ball
	push	lr
	ldrb	r0,[r4,9h]
	cmp		r0,3h
	bcc		@@CanSpiderBall
	sub		r0,1h
	strb	r0,[r4,9h]
	b 		@@end
@@CanSpiderBall:	
	ldrh	r0,[r4]
	mov		r1,88h
	lsl		r1,r1,2h
	and		r1,r0
	lsr		r1,r1,2h
	cmp		r1,88h				; check if left + L is pressed
	beq		@@LeftWallCheck
	mov		r1,84h
	lsl		r1,r1,2h
	and		r0,r1
	cmp		r0,r1				; check if right + L was pressed
	beq		@@RightWallCheck
@@UpDownCheck:	
	ldrh	r0,[r4]				; read input
	mov		r1,080h
	lsl		r1,r1,2h
	and		r0,r1				; check if + L is pressed
	cmp		r0,r1
	beq		@@DisFlagCheck
	ldrh	r0,[r4]
	mov		r1,90h				; check if + L is pressed
	lsl		r1,r1,2h
	and		r0,r1
	cmp		r0,r1
	; beq		@@InstantUPOrLCheck
	beq		@@CeilingCheck
	b 		@@end
; @@InstantUPOrLCheck:	
	; ldrh	r0,[r4,4h]			; Check for immediate input L or up
	; and		r0,r1
	; cmp		r0,0h				
	; bne		@@CeilingCheck
	; b		@@end
@@DisFlagCheck:
	ldrb	r0,[r4,9h]			; check the mark just cancelled
	cmp		r0,0h				; 1 if just canceled
	beq		@@CheckUpDown
	cmp		r0,1h				
	bhi		@@CheckPressing		; greater than 1 will continue to check for instant input
	add		r0,1h
	strb	r0,[r4,9h]		; +1 Lets the instant input check start at the next frame, preventing it from closing immediately after activation
	b 		@@end
@@CheckPressing:
	ldrh	r0,[r4,4h]						
	and		r1,r0				; check if there is an immediate input for L or L
	cmp		r1,0h
	bne		@@DisFlagReturnZero
	b 		@@end
@@DisFlagReturnZero:
	mov		r0,0h
	strb	r0,[r4,9h]			; just removed mark removal
@@CheckUpDown:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,1h
	sub		r1,1Ch
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	; and		r0,r7
	cmp		r0,0h
	bne		@@FloorBorder
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,1h
	add		r1,1Ch
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	; and		r0,r7
	cmp		r0,0h
	beq		@@CeilingCheck
@@FloorBorder:
	mov		r0,1h
	b 		@@WritePose
@@CeilingCheck:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	sub		r1,1Ch
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@CeilingBorder
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	add		r1,1Ch
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@CeilingBorder
	b 		@@end
@@CeilingBorder:
	ldrh	r0,[r5,14h]
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,3Ch
	strh	r0,[r5,14h]				; correct Y
	mov		r0,2h
	b 		@@WritePose
@@LeftWallCheck:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@LeftWallBorder
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	; add		r0,1h
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@UpDownCheck
@@LeftWallBorder:
	ldrh	r0,[r5,12h]
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,1Ch
	strh	r0,[r5,12h]				; correct X
	mov		r0,3h
	b 		@@WritePose
@@RightWallCheck:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@RightWallBorder
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	; add		r0,1h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@RightWallBorder
	b 		@@UpDownCheck
@@RightWallBorder:
	ldrh	r0,[r5,12h]
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,23h
	strh	r0,[r5,12h]
	mov		r0,4h
@@WritePose:
	strb	r0,[r4,8h]
	mov		r0,0h
	strh	r0,[r5,16h]
	strh	r0,[r5,18h]				; speed returns to zero
	strb	r0,[r4,9h]				; unmark zero
	ldr		r0,=24Fh
	bl		PlaySound
@@end:
	pop		r1
	bx		r1
.pool	
	
SpiderBallOnFloorPose:				; ground line
	push	lr
	mov		r0,0h
	strh	r0,[r5,16h]				; X speed returns to zero
	ldrb	r1,[r4,9h]				; Read the pose switch button and keep the flag
	cmp		r1,0h
	beq		@@NoPressStilling
	and		r1,r7					; remove excess data
	ldrh	r0,[r4]
	and		r0,r1					; check if the marked direction is pressed
	cmp		r0,0h
	bne		@@StillingPress
@@PressStillingReturnZero:
	mov		r0,0h
	strb	r0,[r4,9h]				; continue marking to zero
	b		@@NoPressStilling
@@StillingPress:
	ldrb	r0,[r4,9h]
	mov		r1,1h
	and		r0,r1
	cmp		r0,0h					; check left and right movement
	beq		@@LeftMove
	b		@@RightMove
@@NoPressStilling:
	ldrh	r0,[r4]					; read input
	mov		r1,30h
	and		r0,r1
	cmp		r0,0h
	bne		@@NoEnd
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
;	and		r0,r7
	cmp		r0,0h
	beq		@@TwinCheckDrop
	b 		@@end
@@TwinCheckDrop:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
;	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero	
	b      	@@end
@@NoEnd:	
	strb	r0,[r5,0Eh]				; correction-oriented
	cmp		r0,10h
	beq		@@RightMove
@@LeftMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,1Eh
	sub		r1,1Dh
	sub		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@LeftNoBlock
	ldrh	r0,[r5,12h]				; correct X coordinate
	lsr		r0,r0,6h				
	lsl		r0,r0,6h
	add		r0,1Ch
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]				; check if the key is still pressed
	cmp		r1,0h
	bne		@@FloorToLeftWallOldPressStilling
	mov		r0,3h					; left wall borders Pose	
	mov		r1,20h					; enter left and move up
	b		@@WriteNewPose
@@FloorToLeftWallOldPressStilling:
	and		r1,r7					; remove extra data and keep the original key
	mov		r0,3h
	b		@@WriteNewPose
@@LeftNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	sub		r1,1Dh
	sub		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	bne		@@LeftMoveX
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	add		r1,1Dh
	sub		r1,4h
	bl		CheckBlock				; check if the block has been left on the top
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	bne		@@LeftMoveX
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	add		r1,20h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	bne		@@ChangedNewPose
@@ReturnPoseZero:
	strh	r0,[r4,8h]
	b 		@@end
@@ChangedNewPose:	
	ldrh	r0,[r5,12h]				; correct the coordinates to the right wall
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,23h
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@FloorToRightWallOldPressStilling
	mov		r0,4h					; right wall border
	mov		r1,21h					; enter left and move down
	b		@@WriteNewY
@@FloorToRightWallOldPressStilling:
	mov		r0,1h
	orr		r1,r0
	mov		r0,4h
	b		@@WriteNewY
@@RightMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,1Eh
	add		r1,1Dh
	add		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@RightNoBlock
	ldrh	r0,[r5,12h]				; correct the coordinates on the right wall
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,23h
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@FloorToRightWallOldPressStilling2
	mov		r0,4h					; right wall borders Pose
	mov		r1,10h					; press right and move marker up
	b		@@WriteNewPose			
@@FloorToRightWallOldPressStilling2:
	and		r1,r7
	mov		r0,4h
	b		@@WriteNewPose
@@RightNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	add		r1,1Dh
	add		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	bne		@@RightMoveX
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,20h
	sub		r1,1Dh
	add		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	bne		@@RightMoveX
	ldrh	r0,[r5,14h]					; check dangling
	ldrh	r1,[r5,12h]
	add		r0,20h
	sub		r1,21h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	beq		@@ReturnPoseZero
	ldrh	r0,[r5,12h]
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,1Ch
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@FloorToLeftWallOldPressStilling2
	mov		r0,3h					; left wall borders Pose
	mov		r1,11h					; press right and down to move the marker
	b 		@@WriteNewY
@@FloorToLeftWallOldPressStilling2:
	mov		r0,1h
	orr		r1,r0
	mov		r0,3h
@@WriteNewY:
	ldrh	r2,[r5,14h]				; make Y lower
	add		r2,8h
	strh	r2,[r5,14h]
@@WriteNewPose:
	strb	r0,[r4,8h]
	strb	r1,[r4,9h]
	b		@@end
@@LeftMoveX:
	ldrh	r1,[r5,12h]
	sub		r1,4h
	b		@@WriteNewX
@@RightMoveX:
	ldrh	r1,[r5,12h]
	add		r1,4h
@@WriteNewX:	
	strh	r1,[r5,12h]
@@end:	
	pop		r1
	bx		r1
.pool

SpiderBallOnCeilingPose:			; ceiling line
	push	lr
	mov		r0,0h
	strh	r0,[r5,16h]
	strh	r0,[r5,18h]				; zero all speeds
	ldrb	r1,[r4,9h]				; Read the pose switch button and keep the flag
	cmp		r1,0h
	beq		@@NoPressStilling
	and		r1,r7					; remove excess data
	ldrh	r0,[r4]
	and		r0,r1					; Check if the continuous key is pressed
	cmp		r0,0h
	beq		@@PressStillingReturnZero		
@@StillingPress:
	ldrb	r0,[r4,9h]
	mov		r1,1h
	and		r0,r1
	cmp		r0,0h					; check left and right movement
	beq		@@LeftMove
	b		@@RightMove
@@PressStillingReturnZero:
	mov		r0,0h
	strb	r0,[r4,9h]				; continue marking to zero
@@NoPressStilling:
	ldrh	r0,[r4]					; read input
	mov		r1,30h
	and		r0,r1
	cmp		r0,0h
	bne		@@NoEnd
	ldrh	r0,[r5,14h]				; check if there is no border fall
	ldrh	r1,[r5,12h]
	sub		r1,1Dh
	sub		r0,40h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@TwinCheckDrop
	b 		@@end
@@TwinCheckDrop:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero
	b		@@end
@@NoEnd:	
	mov		r1,30h
	eor		r1,r0
	strb	r1,[r5,0Eh]				; correction-oriented
	cmp		r0,10h
	beq		@@RightMove
@@LeftMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,1Fh
	sub		r1,1Dh
	sub		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@LeftNoBlock
	ldrh	r0,[r5,12h]				; correct X coordinate
	lsr		r0,r0,6h				
	lsl		r0,r0,6h
	add		r0,1Ch
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@CeilingToLeftWallPressStilling
	mov		r0,3h					; border on left wall
	mov		r1,21h					; enter left and down to move
	b		@@WriteNewPose
@@CeilingToLeftWallPressStilling:
	mov		r0,1h
	orr		r1,r0
	mov		r0,3h
	b 		@@WriteNewPose
@@LeftNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	sub		r1,1Dh
	sub		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@LeftMoveX
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	add		r1,1Dh
	sub		r1,4h
	bl		CheckBlock				; check if the block has been left on the far side
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@LeftMoveX
	ldrh	r0,[r5,14h]				; check if there is no border fall
	ldrh	r1,[r5,12h]
	sub		r0,40h
	add		r1,20h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@ChangedNewPose
@@ReturnPoseZero:
	mov		r0,0h
	strh	r0,[r4,8h]
	b		@@end
@@ChangedNewPose:	
	ldrh	r0,[r5,12h]				; Correct the coordinates to the right wall upward
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,23h
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@CeilingToRightWallPressStilling
	mov		r0,4h					; right wall borders Pose
	mov		r1,20h					; left button and move up mark
	b		@@WriteNewY
@@CeilingToRightWallPressStilling:
	and		r1,r7
	mov		r0,4h
	b 		@@WriteNewY
@@RightMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,1Fh
	add		r1,1Dh
	add		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@RightNoBlock
	ldrh	r0,[r5,12h]				; Correct the coordinates to the right wall down
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,23h
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@CeilingToRightWallPressStilling2
	mov		r0,4h					; right wall borders Pose
	mov		r1,11h					; press right and down to move the marker
	b		@@WriteNewPose
@@CeilingToRightWallPressStilling2:
	mov		r0,1h
	orr		r1,r0
	mov		r0,4h
	b 		@@WriteNewPose
@@RightNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	add		r1,1Dh
	add		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@RightMoveX
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,40h
	sub		r1,1Dh
	add		r1,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@RightMoveX
	ldrh	r0,[r5,14h]					; check for hang
	ldrh	r1,[r5,12h]
	sub		r0,40h
	sub		r1,21h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero
	ldrh	r0,[r5,12h]
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,1Ch
	strh	r0,[r5,12h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@CeilingToLeftWallPressStilling2
	mov		r0,3h					; left wall borders Pose
	mov		r1,10h					; press right and up to move the marker
	b 		@@WriteNewY
@@CeilingToLeftWallPressStilling2:
	and		r1,r7
	mov		r0,3h
@@WriteNewY:
	ldrh	r2,[r5,14h]				; make the Y coordinate upward
	sub		r2,8h
	strh	r2,[r5,14h]
@@WriteNewPose:
	strb	r0,[r4,8h]
	strb	r1,[r4,9h]
	b		@@end
@@LeftMoveX:
	ldrh	r1,[r5,12h]
	sub		r1,4h
	b		@@WriteNewX
@@RightMoveX:
	ldrh	r1,[r5,12h]
	add		r1,4h
@@WriteNewX:	
	strh	r1,[r5,12h]
@@end:	
	pop		r1
	bx		r1
.pool

SpiderBallOnLeftWallPose:
	push	lr
	mov		r0,0h
	strh	r0,[r5,16h]
	strh	r0,[r5,18h]				; zero all speeds
	ldrb	r1,[r4,9h]				; read the key and keep the flag
	cmp		r1,0h
	beq		@@NoPressStilling
	and		r1,r7					; remove excess data
	ldrh	r0,[r4]
	and		r0,r1					; check if you keep pressing
	cmp		r0,0h
	beq		@@PressStillingReturnZero		
@@StillingPress:
	ldrb	r0,[r4,9h]
	mov		r1,1h
	and		r0,r1
	cmp		r0,0h					; check up and down movement
	beq		@@UpMove
	b		@@DownMove
@@PressStillingReturnZero:			; once the key is released, the key mark is reset
	mov		r0,0h
	strb	r0,[r4,9h]				; continue marking zero
@@NoPressStilling:
	ldrh	r0,[r4]					; read input
	mov		r1,0C0h					; check if it is pressed
	and		r0,r1
	cmp		r0,0h
	bne		@@NoEnd
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r1,1Dh
	sub		r0,3Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@TwinCheckDrop
	b 		@@end
@@TwinCheckDrop:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,1h
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero
	b 		@@end
@@NoEnd:	
	mov		r1,r0
	lsr		r1,r1,2h				
	mov		r2,30h
	eor		r1,r2
	strb	r1,[r5,0Eh]				; correction-oriented
	cmp		r0,80h
	beq		@@DownMove
@@UpMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	sub		r0,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@UpNoBlock
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h				
	lsl		r0,r0,6h
	sub		r0,4h
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@LeftWallToCeilingPressStilling
	mov		r0,2h					; the ceiling borders
	mov		r1,41h					; enter up and right
	b		@@WriteNewPose
@@LeftWallToCeilingPressStilling:
	mov		r0,1h
	orr		r1,r0
	mov		r0,2h
	b 		@@WriteNewPose
@@UpNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	sub		r0,4h
	sub		r1,1Dh					; check if the line to be reached is out of bound
	bl		CheckBlock				; check the depression in the left wall
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h					
	bne		@@UpMoveY
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
;	add		r0,1h
	sub		r0,4h					; check if the lower part of the line is going out of bound
	sub		r1,1Dh					
	bl		CheckBlock				; continue checking for depressions in the left wall
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h					
	bne		@@UpMoveY
	ldrh	r0,[r5,14h]				; check if it is already floating
	ldrh	r1,[r5,12h]
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@ChangedNewPose
@@ReturnPoseZero:	
	mov		r0,0h
	strh	r0,[r4,8h]
	b		@@end
@@ChangedNewPose:	
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	sub		r0,1h
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@LeftWallToFloorPressStilling
	mov		r0,1h					; the ground borders Pose
	mov		r1,40h					; up button and left move marker
	b		@@WriteNewX
@@LeftWallToFloorPressStilling:
	and		r1,r7
	mov		r0,1h
	b		@@WriteNewX
@@DownMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	; add		r0,1h
	add		r0,4h
	bl		CheckBlock				; check if there is a floor below
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	beq		@@DownNoBlock			
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,3Fh
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@LeftWallToFloorPressStilling2
	mov		r0,1h					; the ground borders Pose
	mov		r1,81h					; press and move the marker right
	b		@@WriteNewPose
@@LeftWallToFloorPressStilling2:
	mov		r0,1h
	orr		r1,r0
	b 		@@WriteNewPose
@@DownNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	; add		r0,1h
	add		r0,4h
	sub		r1,1Dh					; check if the bottom of the line is out of bounds
	bl		CheckBlock				; check the bottom left depression
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@DownMoveY
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch					; check if the top of the line is out of bounds
	add		r0,4h
	sub		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@DownMoveY
	ldrh	r0,[r5,14h]				; check if it has fallen
	ldrh	r1,[r5,12h]
	sub		r1,1Dh
	sub		r0,3Ch
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero
	ldrh	r0,[r5,14h]				; correct Y coordinate	
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,3Ch
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@LeftWallToCeilingPressStilling2
	mov		r0,2h					; the ceiling borders
	mov		r1,80h					; press and move marker left
	b 		@@WriteNewX
@@LeftWallToCeilingPressStilling2:
	and		r1,r7
	mov		r0,2h
@@WriteNewX:
	ldrh	r2,[r5,12h]
	sub		r2,8h
	strh	r2,[r5,12h]
@@WriteNewPose:
	strb	r0,[r4,8h]
	strb	r1,[r4,9h]
	b		@@end
@@UpMoveY:
	ldrh	r1,[r5,14h]
	sub		r1,4h
	b		@@WriteNewY
@@DownMoveY:
	ldrh	r1,[r5,14h]
	add		r1,4h
@@WriteNewY:	
	strh	r1,[r5,14h]
@@end:	
	pop		r1
	bx		r1
.pool

SpiderBallOnRightWallPose:			; The right wall borders Pose
	push	lr
	mov		r0,0h
	strh	r0,[r5,16h]
	strh	r0,[r5,18h]				; zero all speeds	
	ldrb	r1,[r4,9h]				; read the key and keep the flag
	cmp		r1,0h
	beq		@@NoPressStilling
	and		r1,r7					; remove excess data
	ldrh	r0,[r4]
	and		r0,r1					; check if you keep pressing
	cmp		r0,0h
	beq		@@PressStillingReturnZero		
@@StillingPress:
	ldrb	r0,[r4,9h]
	mov		r1,1h
	and		r0,r1
	cmp		r0,0h					; check up and down movement
	beq		@@UpMove
	b		@@DownMove
@@PressStillingReturnZero:	; once the key is released, the continuous key mark is reset to zero
	mov		r0,0h
	strb	r0,[r4,9h]				; continue marking to zero
@@NoPressStilling:
	ldrh	r0,[r4]					; read input
	mov		r1,0C0h					; check if it is pressed
	and		r0,r1
	cmp		r0,0h
	bne		@@NoEnd
	ldrh	r0,[r5,14h]				; check if it has fallen
	ldrh	r1,[r5,12h]
	add		r1,1Dh
	sub		r0,3Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@TwinCheckDrop
	b 		@@end
@@TwinCheckDrop:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	add		r0,1h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero
	b 		@@end
@@NoEnd:	
	mov		r1,r0
	lsr		r1,r1,2h				
	mov		r2,30h
	strb	r1,[r5,0Eh]				; correction-oriented
	cmp		r0,80h
	beq		@@DownMove
@@UpMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	sub		r0,4h
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@UpNoBlock
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h				
	lsl		r0,r0,6h
	sub		r0,4h
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@RightWallToCeilingPressStilling
	mov		r0,2h					; the ceiling borders
	mov		r1,40h					; enter up and left
	b		@@WriteNewPose
@@RightWallToCeilingPressStilling:
	and		r1,r7
	mov		r0,2h
	b 		@@WriteNewPose
@@UpNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	sub		r0,4h
	add		r1,1Dh					; check if the line will be out of bounds
	bl		CheckBlock				; check the depression in the left wall
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h					
	bne		@@UpMoveY
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
;	add		r0,1h
	sub		r0,4h					; check if the lower part of the line is out of bounds
	add		r1,1Dh					
	bl		CheckBlock				; continue checking for depressions in the left wall
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h					
	bne		@@UpMoveY
	ldrh	r0,[r5,14h]				; check if it has fallen
	ldrh	r1,[r5,12h]
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@ChangedNewPose
@@ReturnPoseZero:
	mov		r0,0h
	strh	r0,[r4,8h]
	b		@@end
@@ChangedNewPose:	
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	sub		r0,1h
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@RightWallToFloorPressStilling
	mov		r0,1h					; the ground borders Pose
	mov		r1,41h					; up button and right move marker
	b		@@WriteNewX
@@RightWallToFloorPressStilling:
	mov		r0,1h
	orr		r1,r0
	b		@@WriteNewX
@@DownMove:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	; add		r0,1h
	add		r0,4h
	bl		CheckBlock				; check if there is a floor below
	ldrb	r0,[r6,1h]
	cmp		r0,0h
	beq		@@DownNoBlock			
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,3Fh
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@RightWallToFloorPressStilling2
	mov		r0,1h					; the ground borders Pose
	mov		r1,80h					; press and move marker left
	b		@@WriteNewPose
@@RightWallToFloorPressStilling2:
	mov		r0,1h
	and		r1,r7
	b 		@@WriteNewPose
@@DownNoBlock:
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	; add		r0,1h
	add		r0,4h
	add		r1,1Dh					; check the bottom to move
	bl		CheckBlock				; check the bottom left depression			
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@DownMoveY
	ldrh	r0,[r5,14h]
	ldrh	r1,[r5,12h]
	sub		r0,3Ch					; check if the lowermost part is out of bounds
	add		r0,4h
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	bne		@@DownMoveY
	ldrh	r0,[r5,14h]				; check if it has fallen
	ldrh	r1,[r5,12h]
	sub		r0,3Ch
	add		r1,1Dh
	bl		CheckBlock
	ldrb	r0,[r6,1h]
	and		r0,r7
	cmp		r0,0h
	beq		@@ReturnPoseZero
	ldrh	r0,[r5,14h]				; correct Y coordinate
	lsr		r0,r0,6h
	lsl		r0,r0,6h
	add		r0,3Ch
	strh	r0,[r5,14h]
	ldrb	r1,[r4,9h]
	cmp		r1,0h
	bne		@@RightWallToCeilingPressStilling2
	mov		r0,2h					; the ceiling borders
	mov		r1,81h					; press and move marker right
	b 		@@WriteNewX
@@RightWallToCeilingPressStilling2:
	mov		r0,1h
	orr		r1,r0
	add		r0,1h
@@WriteNewX:
	ldrh	r2,[r5,12h]
	add		r2,8h
	strh	r2,[r5,12h]
@@WriteNewPose:
	strb	r0,[r4,8h]
	strb	r1,[r4,9h]
	b		@@end
@@UpMoveY:
	ldrh	r1,[r5,14h]
	sub		r1,4h
	b		@@WriteNewY
@@DownMoveY:
	ldrh	r1,[r5,14h]
	add		r1,4h
@@WriteNewY:	
	strh	r1,[r5,14h]
@@end:	
	pop		r1
	bx		r1
.pool

BallAnimationControl:
	push	r4-r6
	mov		r5,r0
	ldrb	r0,[r4]
	cmp		r0,11h
	beq		@@IsBall
	cmp		r0,12h
	beq		@@IsBall
	cmp		r0,14h
	bne		@@NoBall
@@IsBall:
	ldr		r6,=300137Ch
	ldrh	r1,[r6]				; read input
	ldrb	r2,[r6,8h]			; check if there is Pose of spider ball
	cmp		r2,0h
	beq		@@NoBall			; Spider Ball ends without activation
	; mov		r0,80h
	; lsl		r0,r0,2h
	; and		r0,r1
	; cmp		r0,0h				; check if L is pressed
	; beq		@@NoPressL
	; mov		r0,7h
	; b		@@OnlyChange1D
; @@NoPressL:	
	ldrb	r0,[r6,9h]			
	cmp		r0,0h
	bne		@@SlowAnimation			; if it is continuously moving, the animation is doubled
	cmp		r2,2h
	bhi		@@LeftAndRightWallPose
	ldrh	r1,[r6]
	mov		r0,30h
	and		r0,r1
	cmp		r0,0h
	bne		@@SlowAnimation		; slow animation if left and right are pressed
	cmp		r2,1h
	bne		@@CeilingPose
	ldrb	r0,[r4,1Dh]			; check the spider ball on the ground to stop the animation
	cmp		r0,2h
	bcc		@@OnlyChange1D
	cmp		r0,7h
	beq		@@OnlyChange1D
	mov		r1,2h
	eor		r0,r1
	cmp		r0,2h
	bcc		@@OnlyChange1D
	cmp		r0,7h
	beq		@@OnlyChange1D
	mov		r1,4h
	eor		r0,r1
	b		@@OnlyChange1D
@@CeilingPose:
	ldrb	r0,[r4,1Dh]
	cmp		r0,0h
	bne		@@CeilingNextCheck
	mov		r0,1h
	b		@@OnlyChange1D
@@CeilingNextCheck:
	cmp		r0,3h
	bcc		@@OnlyChange1D
	cmp		r0,5h
	bhi		@@OnlyChange1D
	mov		r1,2h
	eor		r0,r1
	b 		@@OnlyChange1D
@@ChangedNewAnimation:
	mov		r1,0h
	strb	r1,[r4,1Ch]			; animation frame is 0
@@OnlyChange1D:	
	strb	r0,[r4,1Dh]
	b 		@@end
@@LeftAndRightWallPose:	
	ldrh	r1,[r6]				; read input
	mov		r0,0C0h				; check if the top and bottom are pressed
	and		r0,r1
	cmp		r0,0h				; end if no
	bne		@@SlowAnimation
	ldrb	r0,[r4,1Dh]			; read animation
	cmp		r0,5h
	bne		@@WallPoseAnimationNextCheck
	ldrb	r1,[r4,1Ch]
	cmp		r1,1h
	bhi		@@OnlyChange1D
	b		@@WallChangePeer
@@WallPoseAnimationNextCheck:
	cmp		r0,2h
	bcc		@@OnlyChange1D
	cmp		r0,4h
	bhi		@@OnlyChange1D
@@WallChangePeer:
	mov		r1,2h
	eor		r0,r1
	b		@@OnlyChange1D
@@SlowAnimation:	
	ldr		r0,=3000002h
	ldrb	r0,[r0]
	mov		r6,1h
	and		r0,r6
	cmp		r0,0h				; the movement of the spider ball, the animation advances slowly
	beq		@@end
@@NoBall:
	add		r5,1h
	strb	r5,[r4,1Ch]
@@end:
	pop		r4-r6
	bx		r14
.pool	

SpiderBallPaletteChanged:
	push	r0,r1
	ldr		r1,=SamusHeightStage
	ldrb	r0,[r1]
	cmp		r0,2h				; end if not ball stage
	bne		@@end
	ldrb	r0,[r5]
	cmp		r0,10h				; check if the ball is changing
	beq		@@end
	cmp		r0,13h				; check if it is changing
	beq		@@end
	cmp		r0,1Ch
	beq		@@end				; ruled out changing the ball
	cmp		r0,2Bh				; sling ball
	beq		@@CheckSpiderBall
	cmp		r0,20h				; 20 was caught by the statue, So
	bhi		@@end
	
@@CheckSpiderBall:				; all balls that could be spider balls
	mov		r0,0h
	strb	r0,[r5,9h]			; return to zero and flash
	mov		r1,r5
	sub		r1,58h				
	ldrb	r0,[r1,8h]			; check if it is a spider
	cmp		r0,0h
	beq		@@end
	mov		r0,0h
	strb	r0,[r5,6h]			; remove invincible time
	ldr		r0,=SpiderBallPalette
	mov		r1,0A0h
	mul		r1,r3
	add		r0,r1
	mov		r8,r0
	ldrb	r0,[r5,8h]			; body time
	cmp		r0,0h
	beq		@@end
	ldr		r0,=SpiderBallPalette + 40h
	mov		r1,0A0h
	mul		r1,r3
	add		r0,r1
	mov		r10,r0
	
@@end:
	pop		r0,r1
	lsl		r1,r1,2h
	add		r0,r1,r0
	ldr		r3,[r0]
	bx		r14
.pool

.close	